##
# Copyright (c) 2011 Apple Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
##

from twistedcaldav import carddavxml
from twistedcaldav.query import addressbookqueryfilter
import twistedcaldav.test.util
from twistedcaldav.query.addressbookquery import sqladdressbookquery

class Tests(twistedcaldav.test.util.TestCase):

    def test_query(self):
        """
        Basic query test - single term.
        Only UID can be queried via sql.
        """

        filter = carddavxml.Filter(
            *[carddavxml.PropertyFilter(
                carddavxml.TextMatch.fromString("Example"),
                **{"name":"UID"}
            )]
        )
        filter = addressbookqueryfilter.Filter(filter)
        
        sql, args = sqladdressbookquery(filter)
        self.assertTrue(sql.find("UID") != -1)
        self.assertTrue("*Example*" in args)
